#pragma once

typedef BOOL (WINAPI *CHECKINVOKEDLL)(
  HANDLE    hPlugin
);
typedef LPCWSTR (WINAPI *GETPPCNAME)(
  HANDLE    hPlugin
);
typedef int (WINAPI *ADDINFOLINE)(
  HANDLE    hPlugin,
  LPCTSTR   asTitle/*=NULL*/,
  LPCTSTR   asValue/*=NULL*/
);
typedef BOOL (WINAPI *RECONNECT)(
  HANDLE    hPlugin
);
typedef HANDLE (WINAPI *GETOTHERMODULE)(
  HANDLE    hPlugin
);
typedef HRESULT (WINAPI *SETTINGSGET)(
  HANDLE    hPlugin,
  LPCWSTR   asKey,
  DWORD     anValueMaxSize,
  WCHAR*    rsValue
);
typedef HRESULT (WINAPI *SETTINGSSET)(
  HANDLE    hPlugin,
  LPCWSTR   asKey,
  LPCWSTR   asValue
);
typedef HRESULT (WINAPI *SETEDITORHOOK)(
  HANDLE    hPlugin,
  HANDLE    hModule
);


#ifndef PPCSCREENINFO_DEFINED
#define PPCSCREENINFO_DEFINED
typedef struct tag_PPCScreenInfo
{
    int nScreenCX;
    int nScreenCY;
    int nBitsPixel;
} PPCSCREENINFO;
#endif


struct ModuleStartupInfo {
    int                 cbSize;
    int                 cbPsiSize;
    PluginStartupInfo  *psi; //  
    PanelInfo          *pInitialPanelInfo; //  
    PPCSCREENINFO      *pScreenInfo; //  
    DWORD               dwFarVersion;
    LPCWSTR             szLanguage; // English/Russian -  
    BOOL               *pbModuleConfigChanged; //  ,   TRUE    
    // Functions
    CHECKINVOKEDLL      CheckInvokeDll;
    GETPPCNAME          GetPPCName;
    ADDINFOLINE         AddInfoLine;
    RECONNECT           ReConnect;
    GETOTHERMODULE      GetOtherModule;
    SETTINGSGET         SettingsGet;
    SETTINGSSET         SettingsSet;
    SETEDITORHOOK       SetEditorHook;
};

struct ModuleInfo {
    int cbSize;
    TCHAR szName[64];
    TCHAR szTitle[64];
    PluginInfo pi;
};

struct OpenModuleInfo {
    int cbSize;
    OpenPluginInfo opi;
};

struct ModuleUserData {
    int cbSize;
    HANDLE mh_Plugin;
    HANDLE mh_Module;
    DWORD_PTR ceOid; // may be null
    WCHAR wsName[1]; // may be null, and must be last (variable length)
};

typedef struct _FAR_INPUT_RECORD {
    WORD EventType;
    WORD pad;
    union {
        KEY_EVENT_RECORD KeyEvent;
        MOUSE_EVENT_RECORD MouseEvent;
        WINDOW_BUFFER_SIZE_RECORD WindowBufferSizeEvent;
        MENU_EVENT_RECORD MenuEvent;
        FOCUS_EVENT_RECORD FocusEvent;
    } Event;
} FAR_INPUT_RECORD;


//     () .  Module.def
typedef HANDLE (WINAPI *MINITMODULE)(
    HANDLE hPlugin, const ModuleStartupInfo* pMSI, TCHAR** rsError );
typedef void (WINAPI *MCLOSEMODULE)(
    HANDLE hModule);
typedef BOOL (WINAPI *MACTIVATE)(
    HANDLE hModule);
typedef void (WINAPI *MDEACTIVATE)(
    HANDLE hModule);
typedef void (WINAPI *MGETMODULEINFO)(
    struct ModuleInfo *Info );
typedef void (WINAPI *MGETOPENMODULEINFO)(
    HANDLE hModule, OpenModuleInfo *Info );
typedef int (WINAPI *MGETFINDDATA)(
    HANDLE hModule, struct PluginPanelItem **pPanelItem, int *pItemsNumber, int OpMode );
typedef void (WINAPI *MFREEFINDDATA)(
    HANDLE hModule, struct PluginPanelItem *PanelItem, int ItemsNumber);
typedef int (WINAPI *MGETFILES)(
    HANDLE hModule, struct PluginPanelItem *PanelItem, int ItemsNumber, int Move, char *DestPath, int OpMode );
typedef BOOL (WINAPI *MSETDIRECTORY)( /*     ,     */
    HANDLE hModule, LPCWSTR Dir, int OpMode );
typedef BOOL (WINAPI *MEXISTSDIRECTORY)( /*    ,     */
    HANDLE hModule, LPCWSTR Dir, int OpMode );
typedef LPCWSTR (WINAPI *MGETDIRECTORY)( /*     */
    HANDLE hModule );
typedef int (WINAPI *MMAKEDIRECTORY) (
    HANDLE hModule, char *Name, int OpMode );
typedef int (WINAPI *MPUTFILES)(
    HANDLE hModule, struct PluginPanelItem *PanelItem, int ItemsNumber, int Move, int OpMode );
typedef int (WINAPI *MDELETEFILES)(
    HANDLE hModule, struct PluginPanelItem *PanelItem, int ItemsNumber, int OpMode);
typedef int (WINAPI *MPROCESSKEY)(
    HANDLE hModule, int Key, unsigned int ControlState );
typedef void (WINAPI *MCONFIGURE)(
    HANDLE hModule);
typedef HRESULT (WINAPI *MPROCESSEDITORINPUT)(
    HANDLE hModule, const FAR_INPUT_RECORD* Evt);
